#include "activityinfo.h"
#include "ui_activityinfo.h"
#include "track.h"

#include "windowMap.h"
#include "settings.h"

ActivityInfo::ActivityInfo(WindowMap *parent, Settings* settings, Log *log):
    QDialog(parent), log(log),windowMap(parent),settings(settings),
    ui(new Ui::ActivityInfo)
{
    ui->setupUi(this);

    connect(ui->buttonBox, SIGNAL(accepted()), SLOT(accept()));

}




ActivityInfo::~ActivityInfo()
{
    delete ui;
}

void ActivityInfo::accept(){

    this->hide();
}


void ActivityInfo::getSummary(Track* trk){

    // this is for yesterday... so it has to be
    // corrected some day!

    if(trk->getNumPoints()<=0)
        return;


    setWindowTitle(trk->getName());
    //ui->windowTitle(trk->getName());

    ui->startTimeValue->setText(trk->getStartTime().toString(CLEAN_DATE_FORMAT));

    double duration=trk->getDuration();
    double duration_2=trk->getStartTime().secsTo(trk->getEndTime());
    ui->timeValue->setText(stringDateFromSeconds(duration));
    ui->distanceValue->setText(QString::number(trk->getDistance(),'f',2).append(" m"));
    ui->elevationValue->setText(QString::number(trk->getElevationGain(),'f',2).append(" m"));

    ui->avgSpeedValue->setText(QString::number(trk->getAvgSpeed(),'f',2).append(" km/h"));
    ui->maxSpeedValue->setText(QString::number(trk->getMaxSpeed(),'f',2).append(" km/h"));
    ui->avgPaceLabel->setText(QString::number(trk->getAvgPace(),'f',2).append(" min/km"));
    ui->bestPaceValue->setText(QString::number(trk->getBestPace(),'f',2).append(" min/km"));

    ui->elevationGainValue->setText(QString::number(trk->getElevationGain(),'f',2).append(" m"));
    ui->elevationLossValue->setText(QString::number(trk->getElevationLoss(),'f',2).append(" m"));
    ui->minElevationValue->setText(QString::number(trk->getMinElevation(),'f',2).append(" m"));
    ui->maxElevationValue->setText(QString::number(trk->getMaxElevation(),'f',2).append(" m"));

}

void ActivityInfo::updateSummary(){

    log->debug("updating summary");

    if(windowMap->getMode()==Mode_NewActivityMode){
        log->debug("updating with track");
        getSummary(windowMap->getTrack());
    }else if(windowMap->getMode()==Mode_LoadTracksWindow){
        log->debug("updating with trackToSniff");
        log->debug(QString("track to summary:%1").arg(windowMap->getTrackToSniff()->toSumString()));
        getSummary(windowMap->getTrackToSniff());

    }

}
