#ifndef CONSTANTS_H
#define CONSTANTS_H

#ifndef APPLICATION_NAME
#define APPLICATION_NAME GPS Sport Sniffer
#endif

#ifndef ERROR_VERBOSITY
#define ERROR_VERBOSITY 3
#endif

#ifndef WARN_VERBOSITY
#define WARN_VERBOSITY 2
#endif

#ifndef INFO_VERBOSITY
#define INFO_VERBOSITY 1
#endif

#ifndef DEBUG_VERBOSITY
#define DEBUG_VERBOSITY 0
#endif

#ifndef DATE_FORMAT
#define DATE_FORMAT "dd-MM-yyyy"
#endif

#ifndef XML_DATE_FORMAT
#define XML_DATE_FORMAT "yyyy-MM-ddThh:mm:ssZ"
#endif

#ifndef CONTINOUS_DATE_FORMAT
#define CONTINOUS_DATE_FORMAT "dd-MM-yyyy_hh-mm-ss"
#endif

#ifndef CLEAN_DATE_FORMAT
#define CLEAN_DATE_FORMAT "dd-MM-yyyy hh:mm:ss"
#endif

#ifndef APPLICATION_PATH
#define APPLICATION_PATH "/home/user/MyDocs/GPSSniffer/"
#endif

#ifndef TCX_FILE
#define TCX_FILE ".tcx"
#endif

#ifndef GPX_FILE
#define GPX_FILE ".gpx"
#endif

#ifndef TCX_XSI_SCHEMALOCATION
#define TCX_XSI_SCHEMALOCATION "http://www.garmin.com/xmlschemas/TrainingCenterDatabase/v2 http://www.garmin.com/xmlschemas/TrainingCenterDatabasev2.xsd"
#endif

#ifndef GPX_CREATOR
#define GPX_CREATOR "GPS Sport Sniffer v.1.1"
#endif

#ifndef GPX_VERSION
#define GPX_VERSION "1.1"
#endif

#ifndef GPX_XMLNS
#define GPX_XMLNS "http://www.topografix.com/GPX/1/1"
#endif


#ifndef TCX_XMLNS
#define TCX_XMLNS "http://www.garmin.com/xmlschemas/TrainingCenterDatabase/v2"
#endif

#ifndef TCX_XMLNS_XSI
#define TCX_XMLNS_XSI "http://www.w3.org/2001/XMLSchema-instance"
#endif

#ifndef EARTH_RADIUS
#define EARTH_RADIUS 6371
#endif

#ifndef PI
#define PI 3.1415926535897932386
#endif

#ifndef FIRST_LATITUDE
#define FIRST_LATITUDE 41.6105
#endif

#ifndef FIRST_LONGITUDE
#define FIRST_LONGITUDE 0.620667
#endif
// tile size in pixels
const int tdim = 256;

#ifndef DEFAULT_ZOOM
#define DEFAULT_ZOOM 15
#endif

#ifndef MAX_ZOOM
#define MAX_ZOOM 18
#endif

#ifndef MIN_ICC_ZOOM
#define MIN_ICC_ZOOM 8
#endif

#ifndef TIME_SECONDS_POSSITIONING_PAN
#define TIME_SECONDS_POSSITIONING_PAN 7
#endif

#ifndef TIME_MIN_TIMEAUTOSAVE
#define TIME_MIN_TIMEAUTOSAVE 5
#endif

#ifndef WIDTH_DEFAULT
#define WIDTH_DEFAULT 800
#endif

#ifndef HEIGHT_DEFAULT
#define HEIGHT_DEFAULT 480
#endif

enum MapType {  MapTypeGoogleMaps=0,
                MapTypeICC=1,
                MapTypeOpenCycleMaps=2,
                MapTypeOpenStreetMaps=3
};

enum XMLFileType{XMLFile_GPX=0,
                 XMLFile_TCX=1
};

enum Mode {  Mode_NewActivityMode, Mode_LoadTracksWindow
};


#endif // CONSTANTS_H
