#include "log.h"
#include <QDate>
#include <QMessageBox>
#include <QFile>
#include <QDebug>

Log::Log(QString fileText,int verbosity)
    :verbosity(verbosity)
{
    QString name = QString(APPLICATION_PATH);
    name.append(QDate::currentDate().toString(DATE_FORMAT));
    file = new QFile(name.append("_" + fileText));

    if (!file->open(QIODevice::WriteOnly | QIODevice::Text)){
        qDebug() << "Error: Can not write Log file!";
        return;
    }
    QTextStream out(file);
    out << "start logging\n" << file << "out=" << &out << ", verbosity:" << verbosity << "(0->debug, 1->info, 2->warn, 3->error)\n";

}

Log::Log(QWidget *win, QString fileText,int verbosity)
    :verbosity(verbosity)
{
    QString name = QString(APPLICATION_PATH);
    name.append(QDate::currentDate().toString(DATE_FORMAT));

    file = new QFile(name.append("_" + fileText));
    if (!file->open(QIODevice::WriteOnly | QIODevice::Text)){
        QMessageBox::information(win, tr("GPSSniffer"),tr("Error: Can not write Log file!"));

        return;
    }
    QTextStream out(file);
    out << "start logging\n"<< file << "out=" << &out << ", verbosity:" << verbosity << "(0->debug, 1->info, 2->warn, 3->error)\n";

}
Log::~Log(){
    if(file)
        file->close();
    delete file;
}


void Log::setVerbosity(int num){
    verbosity=num;
}

int Log::getVerbosity(){
    return verbosity;
}

void Log::debug(QString msg){
    QTextStream out(file);
    if(&out!=0){
        if(verbosity==0){
            out << QDateTime::currentDateTime().toString(CLEAN_DATE_FORMAT)<< " [DEBUG] " << msg << "\n";
        }
    }
}

void Log::info(QString msg){
    QTextStream out(file);
    if(&out!=0){
       if(verbosity<=1){
            out << QDateTime::currentDateTime().toString(CLEAN_DATE_FORMAT)<< " [INFO] " << msg << "\n";
       }
    }
}

void Log::warn(QString msg){
    QTextStream out(file);
    if(&out!=0){
        if(verbosity<=2){
           out << QDateTime::currentDateTime().toString(CLEAN_DATE_FORMAT)<< " [WARN] " << msg << "\n";
        }
    }
}

void Log::err(QString msg){
    QTextStream out(file);
    if(&out!=0){
        if(verbosity<=3){
            out << QDateTime::currentDateTime().toString(CLEAN_DATE_FORMAT)<< " [ERROR] " << msg << "\n";
        }
    }
}




