// checksum 0xcf61 version 0x30002
/*
  This file was generated by the Mobile Qt Application wizard of Qt Creator.
  MainWindow is a convenience class containing mobile device specific code
  such as screen orientation handling.
  It is recommended not to modify this file, since newer versions of Qt Creator
  may offer an updated version of it.
*/

#include "mainWindow.h"
#include "windowMap.h"
#include "ui_mainWindow.h"

#include <QAction>
#include <QMenu>
#include <QMenuBar>
#include <QMessageBox>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    log = new Log(this,"gpssniffer.log",DEBUG_VERBOSITY);

    settings = new Settings(log);

    windowMap = new WindowMap(this,settings,log);
    windowMap->setWindowTitle(tr("GPSSniffer->Activity"));

    //log->debug("log and windowMap created!");

    QAction *simulateAction = new QAction(tr("Simulate GPS"),this);
    QAction *tracksAction = new QAction(tr("Load tracks"), this);
    QAction *settingsAction = new QAction(tr("Settings"), this);
    // the next line doesn't work in Maemo 5
    //settingsAction->setIcon(QIcon(":/images/shadow.png"));
    QAction *activityAction = new QAction(tr("New activity"), this);
    QAction *quitAction = new QAction(tr("Quit"),this);

    //log->debug("connecting all slots...");
    connect(simulateAction, SIGNAL(triggered()), SLOT(simulate()));
    connect(tracksAction, SIGNAL(triggered()), SLOT(tracks()));
    connect(settingsAction, SIGNAL(triggered()), SLOT(configureSettings()));
    connect(activityAction, SIGNAL(triggered()), SLOT(newActivity()));
    connect(quitAction, SIGNAL(triggered()), SLOT(quit()));

    connect(ui->simulateButton, SIGNAL(clicked()), SLOT(simulate()));
    connect(ui->tracksButton, SIGNAL(clicked()), SLOT(tracks()));
    //connect(ui->settingsButton, SIGNAL(clicked()), SLOT(configureSettings()));
    connect(ui->newActivityButton, SIGNAL(clicked()), SLOT(newActivity()));
    connect(ui->quitButton, SIGNAL(clicked()), SLOT(quit()));
    log->debug("done!");



    //ui->tracksButton->setStyleSheet(ui->tracksButton->styleSheet().append("border-radius: 20px"));

#if defined(Q_OS_SYMBIAN) || defined(Q_OS_WINCE_WM) || defined(Q_WS_MAEMO_5) || defined(Q_WS_MAEMO_6)
        menuBar()->addAction(simulateAction);
        menuBar()->addAction(tracksAction);
        menuBar()->addAction(settingsAction);
        menuBar()->addAction(activityAction);
        menuBar()->addAction(quitAction);
#else
        QMenu *menu = menuBar()->addMenu("&Options");
        menu->addAction(simulateAction);
        menu->addAction(tracksAction);
        menu->addAction(settingsAction);
        menu->addAction(activityAction);
        menu->addAction(quitAction);
#endif
}

MainWindow::~MainWindow()
{
    qDebug()<< "destructor MainWindow";
    delete ui;
    qDebug() << "ui deleted";
    delete windowMap;
    qDebug() << "windowMap deleted";
    delete log;
    qDebug()<< "destructor end";
}

void MainWindow::quit(){
    this->close();
}

void MainWindow::configureSettings(){
    // settings
}


void MainWindow::tracks(){
    log->debug("Load tracks window...");
    windowMap->setOrientation(WindowMap::ScreenOrientationAuto);
    windowMap->setMode(Mode_LoadTracksWindow);
    windowMap->setMenuLoadTracks();
    windowMap->showExpanded();
    this->hide();
}

void MainWindow::simulate(){

    log->debug("new Activity simulating window...");
    windowMap->setOrientation(WindowMap::ScreenOrientationAuto);
    windowMap->setMode(Mode_NewActivityMode);
    windowMap->setSimulateGPS(true);
    windowMap->setMenuActivity();
    log->debug(QString("MAIN WINDOWS SETTINGS CONFIGURED?:%1").arg(settings->getIsConfigured()));
    windowMap->showExpanded();
    this->hide();
}

void MainWindow::newActivity(){
    log->debug("new Activity window...");
    windowMap->setOrientation(WindowMap::ScreenOrientationAuto);
    windowMap->setMode(Mode_NewActivityMode);
    windowMap->setMenuActivity();
    log->debug(QString("MAIN WINDOWS SETTINGS CONFIGURED?:%1").arg(settings->getIsConfigured()));
    windowMap->showExpanded();
    this->hide();
}


void MainWindow::setOrientation(ScreenOrientation orientation)
{
#if defined(Q_OS_SYMBIAN)
    // If the version of Qt on the device is < 4.7.2, that attribute won't work
    if (orientation != ScreenOrientationAuto) {
        const QStringList v = QString::fromAscii(qVersion()).split(QLatin1Char('.'));
        if (v.count() == 3 && (v.at(0).toInt() << 16 | v.at(1).toInt() << 8 | v.at(2).toInt()) < 0x040702) {
            qWarning("Screen orientation locking only supported with Qt 4.7.2 and above");
            return;
        }
    }
#endif // Q_OS_SYMBIAN

    Qt::WidgetAttribute attribute;
    switch (orientation) {
#if QT_VERSION < 0x040702
    // Qt < 4.7.2 does not yet have the Qt::WA_*Orientation attributes
    case ScreenOrientationLockPortrait:
        attribute = static_cast<Qt::WidgetAttribute>(128);
        break;
    case ScreenOrientationLockLandscape:
        attribute = static_cast<Qt::WidgetAttribute>(129);
        break;
    default:
    case ScreenOrientationAuto:
        attribute = static_cast<Qt::WidgetAttribute>(130);
        break;
#else // QT_VERSION < 0x040702
    case ScreenOrientationLockPortrait:
        attribute = Qt::WA_LockPortraitOrientation;
        break;
    case ScreenOrientationLockLandscape:
        attribute = Qt::WA_LockLandscapeOrientation;
        break;
    default:
    case ScreenOrientationAuto:
        attribute = Qt::WA_AutoOrientation;
        break;
#endif // QT_VERSION < 0x040702
    };
    setAttribute(attribute, true);
}

void MainWindow::showExpanded()
{
#ifdef Q_OS_SYMBIAN
    showFullScreen();
#elif defined(Q_WS_MAEMO_5)
    showMaximized();
#else
    show();
#endif
}

void MainWindow::closeEvent(QCloseEvent *event){

}
