#include "settings.h"

Settings::Settings(Log *log)
    :servicesStarted(false),isConfigured(false),log(log),autosaveInterval(5){

    horizontalAccuracy=200; //200
    verticalAccuracy=100;   //100
    trackToSniffColor="#ff0000";
    trackColor="#5bff24";
}

Settings::Settings(const Settings& set, Log *log):
    activity(set.activity),gpsInterval(set.gpsInterval),mapType(set.mapType),isOnline(set.isOnline)
  ,xmlFile(set.xmlFile),servicesStarted(set.servicesStarted),isConfigured(set.isConfigured),log(log){
    log->debug("--Settings 2n constuctor ---");
    log->debug("isConfigured:" + isConfigured);
    horizontalAccuracy=200;
    verticalAccuracy=100;
    trackToSniffColor="#ff0000";
    trackColor="#5bff24";
}



QString Settings::toString(){

    return activity;
}

Settings& Settings::operator= (const Settings &set){
    activity=set.activity;
    gpsInterval=set.gpsInterval;
    mapType=set.mapType;
    isOnline=set.isOnline;
    xmlFile=set.xmlFile;
    servicesStarted=set.servicesStarted;

    return(*this);
}

int operator== (const Settings& a, const Settings& b)
{
if (a.activity==b.activity&&a.gpsInterval==b.gpsInterval&&a.mapType==b.mapType&&a.isOnline==b.isOnline&&a.xmlFile==b.xmlFile &&a.servicesStarted==b.servicesStarted)
    return 1;
else
    return 0;
}

int operator!= (const Settings& a, const Settings& b)
{
if (a.activity!=b.activity||a.gpsInterval!=b.gpsInterval||a.mapType!=b.mapType||a.isOnline!=b.isOnline||a.xmlFile!=b.xmlFile || a.servicesStarted!=b.servicesStarted)
    return 1;
else
    return 0;
}

QDataStream& operator << (QDataStream &stream, const Settings &a)
{
    QString settings = QString("Settings{latitude=%1, longitude=%2}").arg(a.activity).arg(a.gpsInterval);

    stream << settings;
    return stream;
}
