#ifndef SETTINGS_H
#define SETTINGS_H

#include "log.h"

class Settings{

private:

    QString activity;
    int gpsInterval;
    MapType mapType;
    bool isOnline;
    QString xmlFile;
    QString xmlType;
    bool servicesStarted;
    bool isConfigured;
    int autosaveInterval;
    int horizontalAccuracy;
    int verticalAccuracy;
    QString trackColor;
    QString trackToSniffColor;
    Log *log;

public:

    explicit Settings(Log *log=0);
    explicit Settings(const Settings&, Log *log=0);

    inline QString getTrackColor(){return trackColor;}
    inline void setTrackColor(QString color){trackColor=color;}

    inline QString getTrackToSniffColor(){return trackToSniffColor;}
    inline void setTrackToSniffColor(QString color){trackToSniffColor=color;}

    inline bool getIsConfigured(){return isConfigured;}
    inline void setIsConfigured(bool configured){isConfigured=configured;}

    inline int getAutosaveInterval(){return autosaveInterval;}
    inline void setAutosaveInterval(int interval){autosaveInterval=interval;}

    inline QString getActivity(){return activity;}
    inline void setActivity(QString activity){this->activity=activity;}

    inline int getGpsInterval(){return gpsInterval;}
    inline void setGpsInterval(int interval){this->gpsInterval=interval;}

    inline MapType getMapType(){return mapType;}
    inline void setMapType(MapType mapType){this->mapType=mapType;}

    inline QString getXMLType(){return xmlType;}
    inline void setXMLType(QString type){xmlType=type;}


    inline bool getIsOnline(){return isOnline;}
    inline void setIsOnline(bool isOnline){this->isOnline=isOnline;}

    inline bool areServicesStarted(){return servicesStarted;}
    inline void setServicesStarted(bool st){this->servicesStarted=st;}

    inline QString getXmlFile(){return xmlFile;}
    inline void setXmlFile(QString xmlFile){this->xmlFile=xmlFile;}

    inline int getHorizontalAccuracy(){return horizontalAccuracy;}
    inline void setHorizontalAccuracy(int value){horizontalAccuracy=value;}

    inline int getVerticalAccuracy(){return verticalAccuracy;}
    inline void setVerticalAccuracy(int value){verticalAccuracy=value;}

    QString toString();

    Settings& operator= (const Settings&);

    friend int operator== (const Settings&, const Settings&);
    friend int operator!= (const Settings&, const Settings&);
    friend QDataStream& operator<< (QDataStream&, const Settings&);


};


#endif // SETTINGS_H
