#ifndef SETTINGSWINDOW_H
#define SETTINGSWINDOW_H

#include "settings.h"
#include <QDialog>
#include <QDir>

class WindowMap;

namespace Ui {
    class SettingsWindow;
}

class SettingsWindow:public QDialog
{
    Q_OBJECT

public:
    explicit SettingsWindow(WindowMap *parent = 0,Settings *sett=0, Log *log=0);
    virtual ~SettingsWindow();
    Settings *activitySettings;
    WindowMap *activityMap;

private:
    void closeEvent(QCloseEvent *event);
    void showEvent(QShowEvent *);

    QString getExtension();
    void accept();
    int intervalFromCombo(int index);
    QDir* currentDir;
    Log *log;
    Ui::SettingsWindow *ui;
    QString trackName;

private slots:
    void setActivityType();
    void browse();
    void setColor();
    void changeEditText();
    void changeTCXTypeFile(bool);
};

#endif // SETTINGSWINDOW_H
