#ifndef UTILS_H
#define UTILS_H

#include <math.h>
#include <QPoint>
#include <QPointF>

class Track;
class GpsPoint;
class QXmlStreamReader;

uint qHash(const QPoint&);
QPointF tileForCoordinate(qreal, qreal, int);
qreal longitudeFromTile(qreal, int);
qreal latitudeFromTile(qreal, int);
qreal max(qreal, qreal);
qreal min(qreal, qreal);
double toRad(double);
Track* readFromXML(QString fileName);
double parseTCXAltitude(QXmlStreamReader& xml);
QString parseAttribute(QXmlStreamReader& xml, const char* stringElement, const char* stringAttribute);
QString parseStringElement(QXmlStreamReader& xml,const char* stringElement);
GpsPoint* parseTCXGpsPoint(QXmlStreamReader& xml);
GpsPoint* parseGPXGpsPoint(QXmlStreamReader& xml);
QString stringDateFromSeconds(double);
int calculateZoom(Track t);

#endif // UTILS_H
